## lomiri-app-launch 0.1.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(lomiri-app-launch VERSION 0.1.4 LANGUAGES C CXX)

##########################
# Version Info
##########################

set(VERSION_MAJOR 0)
set(VERSION_MINOR 1)
set(VERSION_PATCH 4)

set(ABI_VERSION 0)

##########################
# Options
##########################

option (ENABLE_TESTS "Build tests" ON)
option (ENABLE_COVERAGE "Enable coverage reports" ON)
option (USE_SYSTEMD "Use systemd jobs manager instead of POSIX" ON)
option (ENABLE_MIRCLIENT "Enable helper session using mirclient" ON)

set(AA_EXEC_PATH "/usr/bin/aa-exec" CACHE STRING "Path to aa-exec (AppArmor)")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")

set(PACKAGE ${CMAKE_PROJECT_NAME})

##########################
# Dependent Packages
##########################

find_package(PkgConfig REQUIRED)
find_package(GObjectIntrospection REQUIRED)
include(GNUInstallDirs)
include(CheckIncludeFile)
include(CheckFunctionExists)
include(UseGlibGeneration)
include(UseGdbusCodegen)
include(UseConstantBuilder)
include(UseLttngGenTp)

# Workaround for libexecdir on debian
if (EXISTS "/etc/debian_version") 
  set(CMAKE_INSTALL_LIBEXECDIR ${CMAKE_INSTALL_LIBDIR})
  set(CMAKE_INSTALL_FULL_LIBEXECDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBEXECDIR}")
endif()

set(pkglibexecdir "${CMAKE_INSTALL_FULL_LIBEXECDIR}/${CMAKE_PROJECT_NAME}")
set(CMAKE_INSTALL_PKGLIBEXECDIR "${CMAKE_INSTALL_LIBEXECDIR}/${CMAKE_PROJECT_NAME}")
set(CMAKE_INSTALL_FULL_PKGLIBEXECDIR "${CMAKE_INSTALL_FULL_LIBEXECDIR}/${CMAKE_PROJECT_NAME}")
set(CMAKE_INSTALL_FULL_PKGDATADIR "${CMAKE_INSTALL_FULL_DATADIR}/${CMAKE_PROJECT_NAME}")

if(NOT LOMIRI_APP_LAUNCH_ARCH)
	execute_process(COMMAND dpkg-architecture -qDEB_BUILD_MULTIARCH
		OUTPUT_VARIABLE LOMIRI_APP_LAUNCH_ARCH
		OUTPUT_STRIP_TRAILING_WHITESPACE
	)
	if(NOT LOMIRI_APP_LAUNCH_ARCH)
		message(FATAL_ERROR "LOMIRI_APP_LAUNCH_ARCH is empty!")
	endif()
endif()

add_compile_options(
# Because we believe in quality
	-Wall -Werror
	-g
	-pthread
)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

pkg_check_modules(GLIB2 REQUIRED glib-2.0)
include_directories(${GLIB2_INCLUDE_DIRS})

pkg_check_modules(GOBJECT2 REQUIRED gobject-2.0)
include_directories(${GOBJECT2_INCLUDE_DIRS})

pkg_check_modules(GIO2 REQUIRED gio-2.0 gio-unix-2.0)
include_directories(${GIO2_INCLUDE_DIRS})

pkg_check_modules(JSONGLIB REQUIRED json-glib-1.0>=1.1.2)
include_directories(${JSONGLIB_INCLUDE_DIRS})

pkg_check_modules(ZEITGEIST REQUIRED zeitgeist-2.0)
include_directories(${ZEITGEIST_INCLUDE_DIRS})

pkg_check_modules(CLICK REQUIRED click-0.4>=0.4.18)
include_directories(${CLICK_INCLUDE_DIRS})

pkg_check_modules(DBUS REQUIRED dbus-1)
include_directories(${DBUS_INCLUDE_DIRS})

if(${ENABLE_TESTS})
  pkg_check_modules(DBUSTEST REQUIRED dbustest-1>=14.04.0)
  include_directories(${DBUSTEST_INCLUDE_DIRS})
endif()

pkg_check_modules(LTTNG REQUIRED lttng-ust)
include_directories(${LTTNG_INCLUDE_DIRS})

if(ENABLE_MIRCLIENT)
  pkg_check_modules(MIR REQUIRED mirclient)
  include_directories(${MIR_INCLUDE_DIRS})
endif()

pkg_check_modules(LIBERTINE libertine)
include_directories(${LIBERTINE_INCLUDE_DIRS})
if(${LIBERTINE_FOUND})
  add_definitions(-DHAVE_LIBERTINE=1)
endif(${LIBERTINE_FOUND})

pkg_check_modules(CURL libcurl>=7.47)
include_directories(${CURL_INCLUDE_DIRS})

pkg_check_modules(LOMIRI_API REQUIRED liblomiri-api>=0.1.0)
include_directories(${LOMIRI_API_INCLUDE_DIRS})

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")

####################
# lomiri-app-launch-desktop.click-hook
####################

configure_file("data/lomiri-app-launch-desktop.click-hook.in" "${CMAKE_CURRENT_SOURCE_DIR}/debian/lomiri-app-launch-desktop.click-hook" @ONLY)

add_subdirectory(liblomiri-app-launch)
add_subdirectory(tools)
add_subdirectory(utils)

# testing & coverage
if (${ENABLE_TESTS})
  enable_testing ()
  add_subdirectory(tests)
endif ()

if (${ENABLE_COVERAGE})
	find_package(CoverageReport)
	set(filter-list)
	list(APPEND filter-list "/usr/include")
	list(APPEND filter-list "${CMAKE_SOURCE_DIR}/tests/*")
	if (NOT ${CMAKE_BINARY_DIR} STREQUAL ${CMAKE_SOURCE_DIR})
		list(APPEND filter-list "${CMAKE_BINARY_DIR}/*")
	endif()
	ENABLE_COVERAGE_REPORT(
		TARGETS
			lomiri-launcher
			launcher-static
			desktop-hook
		TESTS
			app-store-legacy
			application-icon-finder-test
			application-info-desktop-test
			helper-test
			helper-handshake-test
			info-watcher-zg
			jobs-base-test
			jobs-systemd
			liblal-test
			liblal-cpp-test
			list-apps
			snapd-info-test
		FILTER
			${filter-list}
	)
endif ()

=== liblomiri-app-launch/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})


##########################
# Library
##########################

add_lttng_gen_tp(NAME lomiri-app-launch-trace)

EXECUTE_PROCESS(COMMAND gcc -dumpversion OUTPUT_VARIABLE GCC_VERSION)
if ("${GCC_VERSION}" VERSION_LESS "5.0")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=pedantic")
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden -Wpedantic")
add_definitions ( -DOOM_HELPER="${pkglibexecdir}/oom-adjust-setuid-helper" )
add_definitions ( -DLIBERTINE_LAUNCH="${CMAKE_INSTALL_FULL_BINDIR}/libertine-launch" )
add_definitions ( -DG_LOG_DOMAIN="lomiri-app-launch" )
add_definitions ( -DLOMIRI_APP_LAUNCH_ARCH="${LOMIRI_APP_LAUNCH_ARCH}" )
add_definitions ( -DHELPER_EXEC_TOOL_DIR="${pkglibexecdir}" )
add_definitions ( -DHELPER_HELPER_TOOL="${pkglibexecdir}/systemd-helper-helper" )
add_definitions ( -DAA_EXEC_PATH="${AA_EXEC_PATH}" )
if (${USE_SYSTEMD})
	add_definitions ( -DUSE_SYSTEMD=1 )
endif()

if(ENABLE_MIRCLIENT)
  set(LAL_USE_MIRCLIENT 1)
endif()

configure_file(config.h.in config.h)

set(LAUNCHER_HEADERS
lomiri-app-launch.h
${CMAKE_CURRENT_BINARY_DIR}/config.h
)

set(LAUNCHER_CPP_HEADERS
appid.h
application.h
helper.h
oom.h
registry.h
type-tagger.h
)

set(LAUNCHER_CPP_SOURCES
application.cpp
app-store-base.h
app-store-base.cpp
app-store-click.h
app-store-click.cpp
app-store-legacy.h
app-store-legacy.cpp
app-store-libertine.h
app-store-libertine.cpp
app-store-snap.h
app-store-snap.cpp
helper.cpp
helper-impl.h
registry.cpp
registry-impl.h
registry-impl.cpp
application-impl-base.h
application-impl-base.cpp
application-impl-click.h
application-impl-click.cpp
application-impl-legacy.h
application-impl-legacy.cpp
application-impl-libertine.h
application-impl-libertine.cpp
application-impl-snap.h
application-impl-snap.cpp
application-info-desktop.h
application-info-desktop.cpp
application-icon-finder.h
application-icon-finder.cpp
info-watcher.h
info-watcher.cpp
info-watcher-zg.h
info-watcher-zg.cpp
glib-thread.h
glib-thread.cpp
jobs-base.h
jobs-base.cpp
jobs-systemd.h
jobs-systemd.cpp
jobs-posix.h
jobs-posix.cpp
signal-unsubscriber.h
snapd-info.h
snapd-info.cpp
string-util.h
)

set(LAUNCHER_SOURCES
lomiri-app-launch.cpp
second-exec-core.c
lomiri-app-launch-trace.c
utils.c
utils-shared.c
)

add_custom_target(format
	COMMAND clang-format -i -style=file ${LAUNCHER_CPP_HEADERS} ${LAUNCHER_CPP_SOURCES}
)

set(LAUNCHER_GEN_SOURCES
)

add_gdbus_codegen_with_namespace(LAUNCHER_GEN_SOURCES proxy-socket-demangler com.lomiri.LomiriAppLaunch. proxy ${CMAKE_SOURCE_DIR}/data/com.lomiri.LomiriAppLaunch.SocketDemangler.xml)

add_library(launcher-static ${LAUNCHER_SOURCES} ${LAUNCHER_CPP_SOURCES} ${LAUNCHER_GEN_SOURCES})

target_link_libraries(launcher-static
	${GLIB2_LIBARIES}
	${GOBJECT2_LIBRARIES}
	${LIBUPSTART_LIBRARIES}
	${GIO2_LIBRARIES}
	${LTTNG_LIBRARIES}
	${JSONGLIB_LIBRARIES}
	${CLICK_LIBRARIES}
	${ZEITGEIST_LIBRARIES}
	${MIR_LIBRARIES}
	${LIBERTINE_LIBRARIES}
	${CURL_LIBRARIES}
	-lpthread
	-Wl,--no-undefined
)

add_library(lomiri-launcher SHARED ${LAUNCHER_SOURCES} ${LAUNCHER_CPP_SOURCES} ${LAUNCHER_GEN_SOURCES})

set_target_properties(lomiri-launcher PROPERTIES
	VERSION ${ABI_VERSION}.0.0
	SOVERSION ${ABI_VERSION}
	OUTPUT_NAME "lomiri-app-launch"
	LINK_FLAGS "${ldflags} -Wl,--version-script,${CMAKE_CURRENT_SOURCE_DIR}/liblomiri-app-launch.map"
	LINK_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/liblomiri-app-launch.map"
)

target_link_libraries(lomiri-launcher
	${GLIB2_LIBARIES}
	${GOBJECT2_LIBRARIES}
	${LIBUPSTART_LIBRARIES}
	${GIO2_LIBRARIES}
	${LTTNG_LIBRARIES}
	${JSONGLIB_LIBRARIES}
	${CLICK_LIBRARIES}
	${ZEITGEIST_LIBRARIES}
	${MIR_LIBRARIES}
	${LIBERTINE_LIBRARIES}
	${CURL_LIBRARIES}
	-lpthread
	-Wl,--no-undefined
)

target_include_directories(lomiri-launcher PUBLIC
	${CMAKE_CURRENT_BINARY_DIR}
)

install(
	FILES ${LAUNCHER_HEADERS}
	DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/liblomiri-app-launch-${VERSION_MAJOR}"
)

install(
	FILES ${LAUNCHER_CPP_HEADERS}
	DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/liblomiri-app-launch-${VERSION_MAJOR}/lomiri-app-launch"
)

install(
	TARGETS lomiri-launcher
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

##########################
# Pkg Config
##########################

set(apiversion "${VERSION_MAJOR}")
set(libdir "${CMAKE_INSTALL_FULL_LIBDIR}")
set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

if(ENABLE_MIRCLIENT)
  set(MIRCLIENT_PC_REQ "mirclient")
endif()

configure_file("lomiri-app-launch.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/lomiri-app-launch-${VERSION_MAJOR}.pc" @ONLY)
install(
	FILES "${CMAKE_CURRENT_BINARY_DIR}/lomiri-app-launch-${VERSION_MAJOR}.pc"
	DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

##########################
# Introspection
##########################

include(UseGObjectIntrospection)

set(INTROSPECTION_GIRS)
set(_introspection_files ${LAUNCHER_HEADERS})
set(LomiriAppLaunch_0_gir "lomiri-app-launch")
set(LomiriAppLaunch_0_gir_INCLUDES GObject-2.0)

gir_get_cflags(_cflags)
list_prefix(MIR_C_INCLUDES MIR_INCLUDE_DIRS "-I")
set(LomiriAppLaunch_0_gir_CFLAGS ${c_flags} ${MIR_C_INCLUDES} "-L/usr/local/lib")
set(LomiriAppLaunch_0_gir_LIBS lomiri-app-launch)

list_make_absolute(_abs_introspection_files _introspection_files "${CMAKE_CURRENT_SOURCE_DIR}/")
set(LomiriAppLaunch_0_gir_FILES ${_abs_introspection_files})
set(LomiriAppLaunch_0_gir_SCANNERFLAGS --c-include "lomiri-app-launch.h")
set(LomiriAppLaunch_0_gir_EXPORT_PACKAGES "lomiri-app-launch-${VERSION_MAJOR}")

list(APPEND INTROSPECTION_GIRS LomiriAppLaunch-0.gir)
gir_add_introspections(INTROSPECTION_GIRS)

add_subdirectory(abi-check)

=== tests/CMakeLists.txt ===
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

configure_file ("click-db-dir/test.conf.in" "${CMAKE_CURRENT_BINARY_DIR}/click-db-dir/test.conf" @ONLY)
set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_BINARY_DIR}/click-db-dir/test.conf")

# Google Test

find_package(GMock)

# Helper test

add_executable (helper-test helper-test.cc)
add_definitions ( -DCMAKE_SOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}" )
add_definitions ( -DCMAKE_BINARY_DIR="${CMAKE_CURRENT_BINARY_DIR}" )
target_link_libraries (helper-test launcher-static gtest_main ${GTEST_MAIN_LIBRARIES} ${DBUSTEST_LIBRARIES})

add_test (helper-test helper-test)

# Helper test

add_executable (helper-handshake-test helper-handshake-test.cc)
target_link_libraries (helper-handshake-test launcher-static gtest_main ${GTEST_MAIN_LIBRARIES})

add_test (helper-handshake-test helper-handshake-test)

# libLAL Test

include_directories("${CMAKE_SOURCE_DIR}/liblomiri-app-launch" "${CMAKE_SOURCE_DIR}/utils" "${CMAKE_BINARY_DIR}/liblomiri-app-launch")
add_definitions ( -DSPEW_UTILITY="${CMAKE_CURRENT_BINARY_DIR}/data-spew" )
add_definitions ( -DSESSION_TEMP_FILE="${CMAKE_CURRENT_BINARY_DIR}/liblal-test-session-start-temp" )
add_definitions ( -DSOCKET_DEMANGLER="${CMAKE_BINARY_DIR}/utils/socket-demangler" )
add_definitions ( -DSOCKET_DEMANGLER_INSTALL="${pkglibexecdir}/socket-demangler" )
add_definitions ( -DSOCKET_TOOL="${CMAKE_CURRENT_BINARY_DIR}/socket-tool" )
add_definitions ( -DSNAP_BASEDIR="${CMAKE_CURRENT_SOURCE_DIR}/snap-basedir" )

if(ENABLE_MIRCLIENT)
  set(MIR_MOCK_SRC mir-mock.cpp)
endif()

add_executable (liblal-test
	liblal-test.cc
	${MIR_MOCK_SRC})
target_link_libraries (liblal-test gtest_main ${GTEST_MAIN_LIBRARIES} ${LIBUPSTART_LIBRARIES} ${DBUSTEST_LIBRARIES} launcher-static)

add_executable (liblal-cpp-test
	liblal-cpp-test.cc
	${MIR_MOCK_SRC})
target_link_libraries (liblal-cpp-test gtest_main ${GMOCK_LIBRARIES} ${LIBUPSTART_LIBRARIES} ${DBUSTEST_LIBRARIES} launcher-static)

add_executable (data-spew
	data-spew.c)
target_link_libraries (data-spew ${GLIB2_LIBRARIES})

add_executable (socket-tool
	socket-tool.c)

add_test (NAME liblal-test COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/repeat-until-pass.sh ${CMAKE_CURRENT_BINARY_DIR}/liblal-test)
add_test (NAME liblal-cpp-test COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/repeat-until-pass.sh ${CMAKE_CURRENT_BINARY_DIR}/liblal-cpp-test)

# App Store Legacy

add_executable (app-store-legacy
	app-store-legacy.cpp)
target_link_libraries (app-store-legacy ${GMOCK_LIBRARIES} ${GTEST_MAIN_LIBRARIES} launcher-static ${DBUSTEST_LIBRARIES})

add_test(NAME app-store-legacy COMMAND "${CMAKE_CURRENT_BINARY_DIR}/app-store-legacy" --gtest_list_tests "|" grep "\"^  \"" "|" xargs -n 1 printf "\"--gtest_filter=*.%s\\n\"" "|" xargs -n 1 "${CMAKE_CURRENT_BINARY_DIR}/app-store-legacy")


# Jobs Base Test

add_executable (jobs-base-test
	jobs-base-test.cpp)
target_link_libraries (jobs-base-test ${GMOCK_LIBRARIES} ${GTEST_MAIN_LIBRARIES} launcher-static ${DBUSTEST_LIBRARIES})

add_test(NAME jobs-base-test COMMAND jobs-base-test)

# Jobs Systemd Test

add_executable (jobs-systemd
	jobs-systemd.cpp)
target_link_libraries (jobs-systemd ${GMOCK_LIBRARIES} launcher-static ${DBUSTEST_LIBRARIES})

add_test(NAME jobs-systemd COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/repeat-until-pass.sh ${CMAKE_CURRENT_BINARY_DIR}/jobs-systemd)

# Info Watcher ZG

add_executable (info-watcher-zg
	info-watcher-zg.cpp)
target_link_libraries (info-watcher-zg ${GMOCK_LIBRARIES} launcher-static ${DBUSTEST_LIBRARIES})

add_test(NAME info-watcher-zg COMMAND info-watcher-zg)

# Snapd Info Test

if(CURL_FOUND)
add_definitions ( -DSNAPD_TEST_SOCKET="/tmp/snapd-test-socket" )
add_executable (snapd-info-test
	snapd-info-test.cpp)
target_link_libraries (snapd-info-test gtest_main ${GTEST_MAIN_LIBRARIES} launcher-static)
add_test (NAME snapd-info-test COMMAND snapd-info-test)
endif()

# List Apps

add_executable (list-apps
	list-apps.cpp)
target_link_libraries (list-apps gtest_main ${GTEST_MAIN_LIBRARIES} ${DBUSTEST_LIBRARIES} launcher-static)
add_test (NAME list-apps COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/repeat-until-pass.sh ${CMAKE_CURRENT_BINARY_DIR}/list-apps)

# Application Info Desktop

add_executable (application-info-desktop-test
  application-info-desktop.cpp
)
target_link_libraries (application-info-desktop-test gtest_main ${GMOCK_LIBRARIES} ${DBUSTEST_LIBRARIES} launcher-static)

add_test (NAME application-info-desktop-test COMMAND application-info-desktop-test)

# Application Icon Finder

add_executable (application-icon-finder-test
  # test
  application-icon-finder.cpp

  #sources
  ${CMAKE_SOURCE_DIR}/liblomiri-app-launch/application-icon-finder.cpp)
target_link_libraries (application-icon-finder-test gtest_main ${GTEST_MAIN_LIBRARIES} lomiri-launcher)

add_test (NAME application-icon-finder-test COMMAND application-icon-finder-test)

file(COPY data DESTINATION ${CMAKE_CURRENT_BINARY_DIR})

# Desktop Hook Test

configure_file ("click-desktop-hook-db/test.conf.in" "${CMAKE_CURRENT_BINARY_DIR}/click-desktop-hook-db/test.conf" @ONLY)
configure_file ("desktop-hook-test.sh.in" "${CMAKE_CURRENT_BINARY_DIR}/desktop-hook-test.sh" @ONLY)
add_test (desktop-hook-test desktop-hook-test.sh)

# Formatted code

add_custom_target(format-tests
	COMMAND clang-format -i -style=file
	application-info-desktop.cpp
	app-store-legacy.cpp
	liblal-cpp-test.cc
	liblal-test.cc
	list-apps.cpp
	eventually-fixture.h
	info-watcher-zg.cpp
	jobs-base-test.cpp
	jobs-systemd.cpp
	libertine-service.h
	registry-mock.h
	snapd-info-test.cpp
	snapd-mock.h
	spew-master.h
	systemd-mock.h
	zg-test.cc
	zg-mock.h
)

=== debian/changelog ===
lomiri-app-launch (0.1.4-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 1001_typo-fixes.patch. Applied upstream.
  * debian/copyright:
    + Update auto-generated copyright.in file.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 05 Feb 2023 15:05:32 +0100

## lomiri-app-launch 0.1.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.5)
 
-project(lomiri-app-launch VERSION 0.1.4 LANGUAGES C CXX)
+project(lomiri-app-launch VERSION 0.1.5 LANGUAGES C CXX)
 
 ##########################
 # Version Info
@@ -70,7 +70,7 @@
 )
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")
 
 pkg_check_modules(GLIB2 REQUIRED glib-2.0)
 include_directories(${GLIB2_INCLUDE_DIRS})
@@ -128,6 +128,7 @@
 
 configure_file("data/lomiri-app-launch-desktop.click-hook.in" "${CMAKE_CURRENT_SOURCE_DIR}/debian/lomiri-app-launch-desktop.click-hook" @ONLY)
 
+add_subdirectory(data)
 add_subdirectory(liblomiri-app-launch)
 add_subdirectory(tools)
 add_subdirectory(utils)

=== debian/changelog ===
lomiri-app-launch (0.1.5-2ubuntu1) lunar; urgency=medium

  * debian/liblomiri-app-launch0.symbols
    - Remove. l-a-l is a C++ codebase that does not explicitly try to
      manage symbol visibility, and so the specific set of symbols exported
      is annoyingly architecture- and compiler-option-dependent.
      Use shlibs instead; the default -VUpstream-Version is suitable

 -- Christopher James Halse Rogers <raof@ubuntu.com>  Wed, 22 Mar 2023 11:48:05 +1100

lomiri-app-launch (0.1.5-2) unstable; urgency=medium

  * debian/patches:
    + Trivial rebase of 2003_remove-werror.patch.
    + Add 1001_install-systemd-target-on-linux-any-only.patch. Only install
      systemd target if systemd is available.
  * debian/control:
    + Add to B-D: systemd [linux-any].

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 27 Feb 2023 10:01:38 +0100

lomiri-app-launch (0.1.5-1) unstable; urgency=medium

  * New upstream release.
    - Provide lal-application-end.target for systemd. Ensuring app closure
      at end of the Lomiri session.
    - Skip flaky part of unit test.
  * debian/patches:
    + Add 0001_CMakeLists.txt-Post-release-fix-of-VERSION-variable.patch
      (cherry-picked from upstream).
  * debian/lomiri-app-launch.install:
    + Add systemd target 'lal-application-end.target'
  * debian/liblomiri-app-launch0.symbols:
    + Update symbols.
  * debian/copyright:
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 26 Feb 2023 18:33:56 +0100

=== debian/control ===
Source: lomiri-app-launch
Section: gnome
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Marius Gripsgard <marius@ubports.com>,
Build-Depends: abi-compliance-checker,
               cmake,
               cmake-extras (>= 1.5-7~),
               dbus-test-runner,
               debhelper-compat (= 13),
               googletest,
               libclick-dev,
               libcurl4-gnutls-dev,
               libdbus-1-dev,
               libdbustest1-dev (>= 14.04.0),
               libgirepository1.0-dev,
               libglib2.0-dev,
               libgtest-dev,
               libjson-glib-dev (>= 1.1.2),
               liblttng-ust-dev,
               libproperties-cpp-dev,
               liblomiri-api-dev (>= 0.1.0),
               libzeitgeist-2.0-dev,
               gobject-introspection,
               pkg-kde-tools,
               python3-dbusmock,
               systemd [linux-any],
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: http://gitlab.com/ubports/development/core/lomiri-app-launch
Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-app-launch.git
Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-app-launch/

Package: lomiri-app-launch
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         dbus-user-session,
         zeitgeist-core,
Multi-Arch: foreign
Description: User space daemon for launching applications
 Application launching system and associated utilities that is used to
 launch applications in a standard and confined way.
 .
 This package provides the Lomiri App Launch user space daemon.

Package: lomiri-app-launch-tools
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         lomiri-app-launch (= ${binary:Version})
Replaces: upstart-app-launch-tools,
          ubuntu-app-launch-tools,
Provides: upstart-app-launch-tools,
          ubuntu-app-launch-tools,
Description: Tools for working wtih launched applications
 Application launching system and associated utilities that is used to
 launch applications in a standard and confined way.
 .
 This package provides tools for working with Lomiri App Launch.

Package: liblomiri-app-launch0
Section: libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         lomiri-app-launch (= ${binary:Version}),
#         lomiri-pasted,
Recommends:
         libertine-xmir-tools [amd64 armhf arm64 i386],
Pre-Depends: ${misc:Pre-Depends},
Multi-Arch: same
Description: library for sending requests to Lomiri App Launch
 Application launching system and associated utilities that is used to
 launch applications in a standard and confined way.
 .
 This package contains shared libraries to be used by applications.

Package: liblomiri-app-launch-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         gir1.2-lomiriapplaunch-0 (= ${binary:Version}),
         libglib2.0-dev,
         libproperties-cpp-dev,
         liblomiri-app-launch0 (= ${binary:Version}),
Pre-Depends: ${misc:Pre-Depends},
Multi-Arch: same
Description: library for sending requests to the Lomiri App Launch
 Application launching system and associated utilities that is used to
 launch applications in a standard and confined way.
 .
 This package contains files that are needed to build applications.

Package: gir1.2-lomiriapplaunch-0
Section: introspection
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         liblomiri-app-launch0 (= ${binary:Version}),
         ${gir:Depends},
Pre-Depends: ${misc:Pre-Depends}
Recommends: lomiri-app-launch (= ${binary:Version})
Multi-Arch: same
Description: typelib file for liblomiri-app-launch4
 Application launching system and associated utilities that is used to
 launch applications in a standard and confined way.
 .
 Interface for starting apps and getting info on them.
 .
 This package can be used by other packages using the GIRepository format to
 generate dynamic bindings for liblomiri-app-launch0.

## lomiri-app-launch 0.1.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,16 @@
 cmake_minimum_required(VERSION 3.5)
 
-project(lomiri-app-launch VERSION 0.1.5 LANGUAGES C CXX)
+project(lomiri-app-launch VERSION 0.1.6 LANGUAGES C CXX)
 
 ##########################
 # Version Info
 ##########################
 
-set(VERSION_MAJOR 0)
-set(VERSION_MINOR 1)
-set(VERSION_PATCH 4)
+set(SOVERSION_MAJOR 0)
+set(SOVERSION_MINOR 0)
+set(SOVERSION_PATCH 0)
 
-set(ABI_VERSION 0)
+set(ABI_VERSION ${SOVERSION_MAJOR})
 
 ##########################
 # Options

=== data/CMakeLists.txt ===
if (USE_SYSTEMD)
    pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
    install(FILES "lal-application-end.target" DESTINATION "${SYSTEMD_USER_UNIT_DIR}")
endif ()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")
 
 configure_file ("click-db-dir/test.conf.in" "${CMAKE_CURRENT_BINARY_DIR}/click-db-dir/test.conf" @ONLY)
 set_directory_properties (PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${CMAKE_CURRENT_BINARY_DIR}/click-db-dir/test.conf")

=== debian/changelog ===
lomiri-app-launch (0.1.6-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 0001_CMakeLists.txt-Post-release-fix-of-VERSION-variable.patch.
      Fixed upstream.
    + Upstream 1001_install-systemd-target-on-linux-any-only.patch.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 01 Mar 2023 08:42:00 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: lomiri-app-launch
 Section: gnome
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
  Marius Gripsgard <marius@ubports.com>,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Get full logs in tests
export G_MESSAGES_DEBUG=all

# Ensure tests fail with criticals
#export G_DEBUG=fatal_criticals

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Uncomment this to be more picky with non-updated .symbols files
#export DPKG_GENSYMBOLS_CHECK_LEVEL=4

include /usr/share/dpkg/architecture.mk

include /usr/share/dpkg/buildflags.mk
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export QT_SELECT := 5

undefine DBUS_SESSION_BUS_ADDRESS
undefine DBUS_SYSTEM_BUS_ADDRESS

%:
	dh $@ --with gir --with pkgkde_symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- -DENABLE_MIRCLIENT=off

override_dh_missing:
	dh_missing --fail-missing

override_dh_installdeb:
	sed -e"s/#MULTIARCH#/$(DEB_HOST_MULTIARCH)/g" \
		debian/lomiri-app-launch.postinst.in \
		> debian/lomiri-app-launch.postinst
	dh_installdeb

override_dh_auto_test:
	mkdir -p $(CURDIR)/debian/test-home/.local/share/
	export HOME=$(CURDIR)/debian/test-home \
	    && export XDG_DATA_HOME=$(CURDIR)/debian/test-home/.local/share \
	    && dh_auto_test --no-parallel

override_dh_clean:
	rm -Rfv $(CURDIR)/debian/test-home/
	dh_clean

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

## lomiri-app-launch 0.1.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.5)
 
-project(lomiri-app-launch VERSION 0.1.6 LANGUAGES C CXX)
+project(lomiri-app-launch VERSION 0.1.9 LANGUAGES C CXX)
 
 ##########################
 # Version Info
@@ -32,6 +32,14 @@
 ##########################
 
 find_package(PkgConfig REQUIRED)
+
+if (USE_SYSTEMD)
+	pkg_check_modules(SYSTEMD systemd)
+	if (NOT SYSTEMD_FOUND)
+		message(FATAL_ERROR "SYSTEMD has not been found!")
+	endif ()
+endif ()
+
 find_package(GObjectIntrospection REQUIRED)
 include(GNUInstallDirs)
 include(CheckIncludeFile)
@@ -134,12 +142,12 @@
 add_subdirectory(utils)
 
 # testing & coverage
-if (${ENABLE_TESTS})
+if (ENABLE_TESTS)
   enable_testing ()
   add_subdirectory(tests)
 endif ()
 
-if (${ENABLE_COVERAGE})
+if (ENABLE_COVERAGE)
 	find_package(CoverageReport)
 	set(filter-list)
 	list(APPEND filter-list "/usr/include")

=== data/CMakeLists.txt ===
##
##  Systemd Unit File
##

if (USE_SYSTEMD)
	pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
	install(FILES "lal-application-end.target" DESTINATION "${SYSTEMD_USER_UNIT_DIR}")
endif()

=== liblomiri-app-launch/CMakeLists.txt ===
--- 
+++ 
@@ -133,7 +133,7 @@
 add_library(lomiri-launcher SHARED ${LAUNCHER_SOURCES} ${LAUNCHER_CPP_SOURCES} ${LAUNCHER_GEN_SOURCES})
 
 set_target_properties(lomiri-launcher PROPERTIES
-	VERSION ${ABI_VERSION}.0.0
+	VERSION ${SOVERSION_MAJOR}.${SOVERSION_MINOR}.${SOVERSION_PATCH}
 	SOVERSION ${ABI_VERSION}
 	OUTPUT_NAME "lomiri-app-launch"
 	LINK_FLAGS "${ldflags} -Wl,--version-script,${CMAKE_CURRENT_SOURCE_DIR}/liblomiri-app-launch.map"
@@ -162,12 +162,12 @@
 
 install(
 	FILES ${LAUNCHER_HEADERS}
-	DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/liblomiri-app-launch-${VERSION_MAJOR}"
+	DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/liblomiri-app-launch-${SOVERSION_MAJOR}"
 )
 
 install(
 	FILES ${LAUNCHER_CPP_HEADERS}
-	DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/liblomiri-app-launch-${VERSION_MAJOR}/lomiri-app-launch"
+	DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/liblomiri-app-launch-${SOVERSION_MAJOR}/lomiri-app-launch"
 )
 
 install(
@@ -179,18 +179,17 @@
 # Pkg Config
 ##########################
 
-set(apiversion "${VERSION_MAJOR}")
+set(apiversion "${SOVERSION_MAJOR}")
 set(libdir "${CMAKE_INSTALL_FULL_LIBDIR}")
 set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
-set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 
 if(ENABLE_MIRCLIENT)
   set(MIRCLIENT_PC_REQ "mirclient")
 endif()
 
-configure_file("lomiri-app-launch.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/lomiri-app-launch-${VERSION_MAJOR}.pc" @ONLY)
-install(
-	FILES "${CMAKE_CURRENT_BINARY_DIR}/lomiri-app-launch-${VERSION_MAJOR}.pc"
+configure_file("lomiri-app-launch.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/lomiri-app-launch-${SOVERSION_MAJOR}.pc" @ONLY)
+install(
+	FILES "${CMAKE_CURRENT_BINARY_DIR}/lomiri-app-launch-${SOVERSION_MAJOR}.pc"
 	DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
 )
 
@@ -213,7 +212,7 @@
 list_make_absolute(_abs_introspection_files _introspection_files "${CMAKE_CURRENT_SOURCE_DIR}/")
 set(LomiriAppLaunch_0_gir_FILES ${_abs_introspection_files})
 set(LomiriAppLaunch_0_gir_SCANNERFLAGS --c-include "lomiri-app-launch.h")
-set(LomiriAppLaunch_0_gir_EXPORT_PACKAGES "lomiri-app-launch-${VERSION_MAJOR}")
+set(LomiriAppLaunch_0_gir_EXPORT_PACKAGES "lomiri-app-launch-${SOVERSION_MAJOR}")
 
 list(APPEND INTROSPECTION_GIRS LomiriAppLaunch-0.gir)
 gir_add_introspections(INTROSPECTION_GIRS)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -55,6 +55,8 @@
 	socket-tool.c)
 
 add_test (NAME liblal-test COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/repeat-until-pass.sh ${CMAKE_CURRENT_BINARY_DIR}/liblal-test)
+set_property(TEST liblal-test PROPERTY ENVIRONMENT "EVENTUALLY_TIMEOUT=5;REPEAT_UNTIL_PASS_ATTEMPTS=30")
+
 add_test (NAME liblal-cpp-test COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/repeat-until-pass.sh ${CMAKE_CURRENT_BINARY_DIR}/liblal-cpp-test)
 
 # App Store Legacy

=== utils/CMakeLists.txt ===
####################
# desktop-hook
####################

include_directories("${CMAKE_SOURCE_DIR}/liblomiri-app-launch")
add_executable(desktop-hook desktop-hook.c)
set_target_properties(desktop-hook PROPERTIES OUTPUT_NAME "desktop-hook")
target_link_libraries(desktop-hook launcher-static ${CLICK_LIBRARIES})
install(TARGETS desktop-hook RUNTIME DESTINATION "${pkglibexecdir}")

####################
# oom-adjust-setuid-helper
####################

add_executable(oom-adjust-setuid-helper oom-adjust-setuid-helper.c)
set_target_properties(oom-adjust-setuid-helper PROPERTIES OUTPUT_NAME "oom-adjust-setuid-helper")
install(TARGETS oom-adjust-setuid-helper RUNTIME DESTINATION "${pkglibexecdir}")

########################
# systemd-helper-helper
########################

########################
# NOTE: This only can link to libraries that are in
# the base LOMIRI CORE image. Which is basically libc
# and not much else. Don't add libs.
########################

add_definitions ( -DDEMANGLER_PATH="${pkglibexecdir}/socket-demangler" )
add_definitions ( -DAA_EXEC_PATH="${AA_EXEC_PATH}" )
add_executable(systemd-helper-helper systemd-helper-helper.c)
set_target_properties(systemd-helper-helper PROPERTIES OUTPUT_NAME "systemd-helper-helper")
install(TARGETS systemd-helper-helper RUNTIME DESTINATION "${pkglibexecdir}")

####################
# socket-demangler
####################

add_executable(socket-demangler-helper socket-demangler.c)
set_target_properties(socket-demangler-helper PROPERTIES OUTPUT_NAME "socket-demangler")
target_link_libraries(socket-demangler-helper ${GIO2_LIBRARIES})
install(TARGETS socket-demangler-helper RUNTIME DESTINATION "${pkglibexecdir}")

=== debian/changelog ===
lomiri-app-launch (0.1.9-3) unstable; urgency=medium

  * debian/control:
    + In B-D:, switch from systemd to systemd-dev. (Closes: #1060620).
    + Drop from B-D: pkg-kde-tools.
  * debian/rules:
    + Stop using pkgkde_symbolshelper.
  * debian/liblomiri-app-launch0.symbols:
    + Drop file. Causing more pain than joy, esp. regarding cross-distro
      maintenance (Debian/Ubuntu).

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 02 Mar 2024 11:47:44 +0100

lomiri-app-launch (0.1.9-2) unstable; urgency=medium

  * debian/patches: Add patch to fix tests on slow hardware (closes: #1062075)

 -- Marius Gripsgard <mariogrip@debian.org>  Fri, 02 Feb 2024 02:35:47 +0100

lomiri-app-launch (0.1.9-1) unstable; urgency=medium

  * New upstream release.

 -- Marius Gripsgard <mariogrip@debian.org>  Thu, 01 Feb 2024 01:11:58 +0100

lomiri-app-launch (0.1.7-1) unstable; urgency=medium

  * New upstream release (closes: #1037763)
  * debian/patches: Drop upstreamed patch
  * debian/control: Use my new debian email

 -- Marius Gripsgard <mariogrip@debian.org>  Thu, 27 Jul 2023 00:38:27 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
- Marius Gripsgard <marius@ubports.com>,
+ Marius Gripsgard <mariogrip@debian.org>,
 Build-Depends: abi-compliance-checker,
                cmake,
                cmake-extras (>= 1.5-7~),
@@ -24,9 +24,8 @@
                liblomiri-api-dev (>= 0.1.0),
                libzeitgeist-2.0-dev,
                gobject-introspection,
-               pkg-kde-tools,
                python3-dbusmock,
-               systemd [linux-any],
+               systemd-dev [linux-any],
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: http://gitlab.com/ubports/development/core/lomiri-app-launch

=== debian/watch ===
version=4
https://gitlab.com/ubports/development/core/lomiri-app-launch/tags .*/lomiri-app-launch-(\d\S+)\.tar\.gz

## lomiri-app-launch 0.1.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.16)
 
-project(lomiri-app-launch VERSION 0.1.9 LANGUAGES C CXX)
+project(lomiri-app-launch VERSION 0.1.10 LANGUAGES C CXX)
 
 ##########################
 # Version Info
@@ -110,7 +110,7 @@
 include_directories(${LTTNG_INCLUDE_DIRS})
 
 if(ENABLE_MIRCLIENT)
-  pkg_check_modules(MIR REQUIRED mirclient)
+  pkg_search_module(MIR REQUIRED mir1client mirclient)
   include_directories(${MIR_INCLUDE_DIRS})
 endif()

=== debian/changelog ===
lomiri-app-launch (0.1.10-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Trivially rebase 2003_remove-werror.patch.
    + Drop 0001-tests-Switch-to-FUNC-compare-to-make-sure-we-can-get.patch.
      Applied upstream.
  * debian/copyright:
    + Update attributions for debian/.
  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 06 Jan 2025 16:47:37 +0100

## lomiri-app-launch 0.1.11

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.16)
 
-project(lomiri-app-launch VERSION 0.1.10 LANGUAGES C CXX)
+project(lomiri-app-launch VERSION 0.1.11 LANGUAGES C CXX)
 
 ##########################
 # Version Info

=== liblomiri-app-launch/CMakeLists.txt ===
--- 
+++ 
@@ -184,7 +184,7 @@
 set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
 
 if(ENABLE_MIRCLIENT)
-  set(MIRCLIENT_PC_REQ "mirclient")
+  set(MIRCLIENT_PC_REQ "${MIR_MODULE_NAME}")
 endif()
 
 configure_file("lomiri-app-launch.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/lomiri-app-launch-${SOVERSION_MAJOR}.pc" @ONLY)

=== debian/changelog ===
lomiri-app-launch (0.1.11-1) unstable; urgency=medium

  * New upstream release.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 13 Jan 2025 09:02:38 +0100

=== debian/rules ===
--- 
+++ 
@@ -25,7 +25,7 @@
 undefine DBUS_SYSTEM_BUS_ADDRESS
 
 %:
-	dh $@ --with gir --with pkgkde_symbolshelper
+	dh $@ --with gir
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DENABLE_MIRCLIENT=off
